chrome.runtime.onInstalled.addListener(function(details) {
    if (["install", "update"].indexOf(details.reason) > -1) {
        var optionsPage = chrome.runtime.getManifest().options_page;
        chrome.tabs.create({
            url: optionsPage + "?" + details.reason + "=true"
        });
    }
});
chrome.runtime.onMessage.addListener(function(message, sender, sendResponse) {

    switch (message.action) {
        case 'speak':
            GoogleSpeak.speak(message.srclang, message.text, function() {
                //speak end
                Common.log('speakend');
                Common.sendMessageToCurrentTab({
                    action: 'speakend'
                });
                chrome.runtime.sendMessage({
                    action: 'speakend'
                });
            });
            break;

        case 'stopspeak':
            GoogleSpeak.stop();
            break;

        case 'save':
            Reminder.save({
                srctext: message.srctext,
                dsttext: message.dsttext,
                srclang: message.srclang,
                dstlang: message.dstlang,
                dictblock : message.dictblock
            });
            break;

        case 'remove':
            Reminder.remove({
                srctext: message.srctext,
                dstlang: message.dstlang
            });
            break;

        case 'markaswrong':
            Reminder.markAsWrong(message.srctext, message.dstlang);
            break;

        case 'markascorrect':
            Reminder.markAsCorrect(message.srctext, message.dstlang);
            break;

        case 'DOMContentLoaded':
            Reminder.showLastSelected();
            break;
        case 'closeallpopups':
            Common.sendMessageToAllTabs({
                action : 'closeallpopups'
            });
            break;
        default:
            break;
    }

    return true;
});

chrome.runtime.onConnect.addListener(function(port) {
    if (port.name === "popup") {
        port.onDisconnect.addListener(function() {
            //popup closed
            GoogleSpeak.stop();
        });
    }
});

Reminder.loadOptions();
chrome.storage.onChanged.addListener(Reminder.loadOptions.bind(Reminder));

chrome.tabs.onActivated.addListener(function(){
    Reminder.showLastSelected();
});