var GoogleSpeak = {
    audio: null,
    queue: [],
    onEnd: null,
    URL: "https://translate.google.com/translate_tts?ie=UTF-8&q=[SPEAK_TEXT]&tl=[SRC_LANG]&total=[TOTAL]&idx=[INDEX]&textlen=[TEXT_LENGTH]&client=t&prev=input",
    speak: function(srclang, text, speakEndCallback) {
        if (this.audio !== null) {
            this.stop();
        } else {
            this.audio = new Audio();
            this.audio.addEventListener("ended", this.onAudioEnded.bind(this));
        }
        this.onEnd = speakEndCallback;
        this.queue = this.buildUrls(srclang, text);
        this.audio.src = this.queue.shift();
        this.audio.play();
    },
    onAudioEnded: function() {
        var next = this.queue.shift();
        if (next) {
            this.audio.src = next;
            this.audio.play();
        } else {
            if (this.onEnd) {
                this.onEnd();
            }
        }
    },
    stop: function() {
        this.queue = [];
        if (this.audio) {
            this.audio.pause();
            this.audio.currentTime = 0.0;
        }
    },
    buildUrls: function(srclang, text) {
        var words = text.split(" ");
        var sentences = [];
        var tempstr = "";
        for (var i = 0; i < words.length; i++) {
            if (tempstr.length + words[i].length < 100) {
                tempstr += " " + words[i];
            } else {
                sentences.push(tempstr.trim());
                tempstr = "";
                i--;
            }
        }
        sentences.push(tempstr);
        var urls = [];
        for (var j = 0; j < sentences.length; j++) {
            var url = this.URL;
            url = url.replace(/\[SPEAK_TEXT\]/g, encodeURIComponent(sentences[j]));
            url = url.replace(/\[SRC_LANG\]/g, srclang);
            url = url.replace(/\[TOTAL\]/g, sentences.length);
            url = url.replace(/\[INDEX\]/g, j);
            url = url.replace(/\[TEXT_LENGTH\]/g, sentences[j].length);
            urls.push(url);
        }
        return urls;
    },
};