Translate.loadOptions(function() {
    if (window.self === window.top) {
        chrome.runtime.sendMessage({
            action: 'DOMContentLoaded',
        });
    }
});
chrome.storage.onChanged.addListener(Translate.loadOptions.bind(Translate));

var debouncedKeydown = Translate.debounce(Translate.keydown.bind(Translate), 250);
document.addEventListener("keydown", debouncedKeydown);

ReminderHelper.setBindings();

document.addEventListener("mousedown", Translate.hideContainer.bind(Translate));
document.addEventListener("mousedown", Translate.stopSpeak.bind(Translate));

chrome.runtime.onMessage.addListener(function(message, sender, sendResponse) {
    if (window.self === window.top) {
        if (message.action === "translate") {
            Translate.translate(message.text, function(resp) {
                var html = this.generateContainerHTML(resp);
                sendResponse({
                    html: html,
                    selectedText: message.text
                });
            });
        }
    }
    if (message.action === "getselectedtext") {
        var seltext = Translate.getSelectionText();
        if (seltext !== "") {
            Translate.translate(seltext, function(resp) {
                var html = this.generateContainerHTML(resp);
                sendResponse({
                    html: html,
                    selectedText: seltext.trim()
                });
            });
        }
    }
    if (message.action === "hidecontainer") {
        Translate.hideContainer();
    }
    if (message.action === "speakend") {
        Translate.onSpeakEnd();
    }
    if (message.action === "idlecheck") {
        sendResponse({
            isIdle: ReminderHelper.getIsIdle()
        });
    }
    if (message.action === "showreminder") {
        var item = message.item;
        ReminderHelper.showReminder(item);
    }
    if (message.action === "closeallreminders") {
        ReminderHelper.closeReminder();
    }
    if (message.action === "closeallpopups") {
        Translate.closePopup();
    }
    return true;
});

if (window.self === window.top) {
    /**
    *
    * !importantlar için bir de dom üzerinden inject ediyoruz.
    *
    **/

    var mainCss = chrome.extension.getURL('css/translate_popup.css');
    Common.injectCss(mainCss);
}

var debouncedReposition = Translate.debounce(ReminderHelper.rePositionReminder.bind(ReminderHelper), 250);
window.addEventListener('resize', debouncedReposition);