var Translate = {
    container: null,
    dudakPayi: 5,
    words: null,
    // xhrUrl: "https://translate.googleapis.com/translate_a/single?dt=t&dt=bd&client=gtx&q=[TRANSLATE_TEXT]&hl=[DST_LANG]&sl=[SRC_LANG]&tl=[DST_LANG]&dj=1&source=bubble",
    xhrUrl: "https://translate.googleapis.com/translate_a/single?dt=t&dt=bd&dt=ex&dt=ld&dt=md&dt=qca&dt=rw&dt=rm&dt=ss&dt=t&dt=at&client=gtx&q=[TRANSLATE_TEXT]&hl=[DST_LANG]&sl=[SRC_LANG]&tl=[DST_LANG]&dj=1&source=bubble",
    get: function(url, callback) {
        var xhr = new XMLHttpRequest();
        var me = this;
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4) {
                var json = null;
                try {
                    json = JSON.parse(xhr.responseText);
                    callback.call(me, json, xhr);
                } catch (e) {
                    callback.call(me, false, xhr);
                }
            }
        };
        xhr.open("GET", url, true);
        xhr.send();
    },
    getSelectionText: function() {
        var sel = window.getSelection();
        var html = sel.toString();
        return html.trim();
    },
    getSelectionTextPos: function() {
        var ret = null;
        var sel = window.getSelection();
        if (sel.rangeCount) {
            var range = sel.getRangeAt(0);
            range.collapse(true);
            var dummy = document.createElement("span");
            range.insertNode(dummy);
            var rect = dummy.getBoundingClientRect();
            ret = {
                x: rect.left,
                y: rect.top,
                width: rect.right - rect.left,
                height: rect.bottom - rect.top
            };
            dummy.parentNode.removeChild(dummy);
        }
        return ret;
    },
    translate: function(text, callback) {
        var me = this;
        var url = this.xhrUrl.replace(/\[TRANSLATE_TEXT\]/g, encodeURIComponent(text));
        url = url.replace(/\[SRC_LANG\]/g, Common.options.SRC_LANG);
        url = url.replace(/\[DST_LANG\]/g, Common.options.DST_LANG);
        this.get(url, callback.bind(me));
    },
    createDomElement: function(prop) {
        var el = document.createElement(prop.node);
        delete prop.node;
        el.setAttribute("class", prop.cls);
        delete prop.cls;
        for (var i in prop) {
            var attr = i;
            var val = prop[attr];
            el.setAttribute(attr, val);
        }
        return el;
    },
    isInput: function(el) {
        var inputTypes = ["password", "textarea", "text"];
        return inputTypes.indexOf(el.type) > -1;
    },
    handleResult: function(googleJson) {
        var translated = this.generateContainerHTML(googleJson);
        if (!this.container) {
            var props = {
                node: "div",
                cls: "translationcontainer___extension",
                style: "display:none;"
            };
            this.container = this.createDomElement(props);
            this.container.addEventListener("mousedown", this.onContainerMouseDown.bind(this));
            document.getElementsByTagName("body")[0].appendChild(this.container);
        }
        this.container.innerHTML = translated;
        this.positionContainer(this.container);
    },
    hasClass: function(element, cls) {
        var className = " " + cls + " ";
        return (" " + element.className + " ").replace(/[\n\t]/g, " ").indexOf(className) > -1;
    },
    escapeHtml: function(unsafe) {
        return unsafe.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#039;");
    },
    onBtnSpeakerMouseDown: function(el) {
        if (this.hasClass(el, "checked___extension")) {
            el.setAttribute("class", "speakerimg___extension");
            this.stopSpeak();
        } else {
            el.setAttribute("class", "speakerimg___extension checked___extension");
            var sentences = this.container.getElementsByClassName("origsentences___extension")[0].innerText;
            var srclang = this.container.getElementsByClassName("origsentences___extension")[0].getAttribute("data-srclang");
            this.speakTextMessage(srclang, sentences);
        }
    },
    onBtnAddButtonMouseDown: function(el) {
        var sentences = this.container.getElementsByClassName("origsentences___extension")[0].innerText;
        var dictblock = this.container.getElementsByClassName("dictblock___extension")[0].innerText;
        var translation = this.container.getElementsByClassName("sentences___extension")[0].innerText;
        var dstlang = this.container.getElementsByClassName("sentences___extension")[0].getAttribute("data-dstlang");
        var srclang = this.container.getElementsByClassName("origsentences___extension")[0].getAttribute("data-srclang");
        var act;
        if (this.hasClass(el, "checked___extension")) {
            el.setAttribute("class", "addbuttonimg___extension");
            act = "remove";
        } else {
            el.setAttribute("class", "addbuttonimg___extension checked___extension");
            act = "save";
        }
        chrome.runtime.sendMessage({
            action: act,
            srctext: sentences,
            dictblock : dictblock,
            dsttext: translation,
            srclang: srclang,
            dstlang: dstlang
        });
    },
    onContainerMouseDown: function(e) {
        if (e.button === 0) {
            if (this.hasClass(e.target, "speakerimg___extension")) {
                this.onBtnSpeakerMouseDown.call(this, e.target);
            }
            if (this.hasClass(e.target, "addbuttonimg___extension")) {
                this.onBtnAddButtonMouseDown.call(this, e.target);
            }
        }
    },
    speakTextMessage: function(srclang, text) {
        chrome.runtime.sendMessage({
            action: "speak",
            text: text,
            srclang: srclang
        });
    },
    stopSpeak: function(e) {
        if (typeof e !== "undefined") {
            if (this.container !== null && this.container.contains(e.target)) {
                return;
            }
        }
        chrome.runtime.sendMessage({
            action: "stopspeak"
        });
    },
    generateContainerHTML: function(googleJson) {
        var translated = "",
            transSentences = "",
            origSentences = "";
        if (googleJson.hasOwnProperty("sentences")) {
            for (var i = 0; i < googleJson.sentences.length; i++) {
                if(googleJson.sentences[i].hasOwnProperty('trans')){
                    transSentences += this.escapeHtml(googleJson.sentences[i].trans) + "\n";
                }
                if(googleJson.sentences[i].hasOwnProperty('orig')){
                    origSentences += this.escapeHtml(googleJson.sentences[i].orig) + "\n";
                }
            }
            transSentences = transSentences.trim();
            origSentences = origSentences.trim();
            translated += '<span class="sentences___extension" data-dstlang="' + Common.options.DST_LANG + '">';
            translated += transSentences;
            translated += '</span>';
            translated += '<span class="origsentences___extension" data-srclang="' + googleJson.src + '">';
            translated += origSentences;
            translated += '</span>';
        }
        var dictTextArr = [];
        if (googleJson.hasOwnProperty("dict")) {
            for (var j = 0; j < googleJson.dict.length; j++) {
                var dictText = '<div class="dictblock___extension"><strong>' + googleJson.dict[j].pos + '</strong> :';
                var terms = [];
                var dtermlength = googleJson.dict[j].terms.length;
                for (var k = 0; k < dtermlength; k++) {
                    terms.push(googleJson.dict[j].terms[k]);
                }
                dictText += "<i>" + terms.join(", ") + "</i></div>";
                dictTextArr.push(dictText);
            }
        }
        if (dictTextArr.length > 0) {
            translated += dictTextArr.join("\n");
        }
        var definitionTextArr = [];
        if (googleJson.hasOwnProperty("definitions")) {
            for (var h = 0; h < googleJson.definitions.length; h++) {
                var definitionText = '<div class="dictblock___extension"><strong>' + googleJson.definitions[h].pos + '</strong> :';
                definitionText+= '<ul class="entry___extension">';
                for (var q = 0; q < googleJson.definitions[h].entry.length; q++) {
                    var example = googleJson.definitions[h].entry[q].example;
                    var def = googleJson.definitions[h].entry[q].gloss;
                    definitionText+= '<li>';
                    definitionText+= '<div class="definition___extension">'+def+'</div>';
                    definitionText+= '<div class="example___extension">'+example+'</div>';
                    definitionText+= '</li>';
                }
                definitionText+= '</ul></div>';
                definitionTextArr.push(definitionText);
            }
        }
        if (definitionTextArr.length > 0) {
            translated += definitionTextArr.join("\n");
        }
        if (typeof googleJson.src !== "undefined") {
            var isAdded = !!this.words && !!this.words[origSentences] && !!this.words[origSentences][Common.options.DST_LANG];
            translated += '<div class="bottom___extension">';
            if (Common.options.REMINDER) {
                translated += '<div class="addbuttonimg___extension' + (isAdded ? ' checked___extension' : '') + '"></div>';
            }
            translated += '<div class="speakerimg___extension"></div>';
            translated += '<div class="detected-language___extension">Detected language : ' + languages[googleJson.src] + '</div>';
            translated += '<div style="clear:both"></div>';
            translated += '<div></div>';
            translated += '</div>';
        }
        return translated;
    },
    positionContainer: function(el) {
        var selectedPos = this.getSelectionTextPos();
        el.style.display = "block";
        var top = (selectedPos.y - el.offsetHeight - this.dudakPayi);
        top = top > 0 ? top : 0;
        var left = selectedPos.x;
        if (document.body.offsetWidth - left < el.offsetWidth) {
            left = (document.body.offsetWidth - el.offsetWidth - this.dudakPayi);
        }
        el.style.top = top + "px";
        el.style.left = left + "px";
    },
    keydown: function(e) {
        this.hideContainer();
        if (e.shiftKey) {
            if (!this.isInput(e.target) || (this.isInput(e.target) && !Common.options.IGNORE_INPUTS)) {
                var text = this.getSelectionText().trim();
                if (text !== "") {
                    this.translate(text, this.handleResult);
                }
            }
        }
    },
    hideContainer: function(e) {
        if (typeof e !== "undefined") {
            if (this.container !== null && this.container.contains(e.target)) {
                return;
            }
        }

        chrome.runtime.sendMessage({
            action: 'closeallpopups'
        });
    },

    closePopup:function(){
        if (this.container) {
            this.container.style.display = "none";
        }
    },

    onSpeakEnd: function() {
        if (this.container) {
            var btnspeaker = this.container.querySelector(".speakerimg___extension");
            if (btnspeaker) {
                btnspeaker.setAttribute("class", "speakerimg___extension");
            }
        }
    },
    loadOptions: function(callback) {
        var me = this;
        chrome.storage.sync.get(Common.options, function(items) {
            Common.options = items;

            chrome.storage.local.get(Common.options, function(itemsLocal){
                Common.options.REMINDER_LAST_RIGHT_MARGIN = itemsLocal.REMINDER_LAST_RIGHT_MARGIN;
                Common.options.REMINDER_LAST_BOTTOM_MARGIN = itemsLocal.REMINDER_LAST_BOTTOM_MARGIN;
                Common.optionsLoaded = true;
                if(typeof callback === 'function'){
                    callback();
                }
            });
            if (Common.options.REMINDER) {
                Translate.loadWords();
            } else {
                me.words = null;
            }
        });
    },
    loadWords: function() {
        var me = this;
        chrome.storage.local.get(null, function(items) {
            me.words = items.words;
        });
    },
    debounce: function(func, wait, immediate) {
        var timeout;
        return function() {
            var context = this,
                args = arguments;
            var later = function() {
                timeout = null;
                if (!immediate) func.apply(context, args);
            };
            var callNow = immediate && !timeout;
            clearTimeout(timeout);
            timeout = setTimeout(later, wait);
            if (callNow) func.apply(context, args);
        };
    }
};