var Options = {
    pageTitle: null,
    MINUTE : 60 * 1000,
    init: function() {
        var me = this;
        this.pageTitle = document.getElementsByClassName("page-title")[0];
        this.restore();
        var btnsave = document.getElementById("btnsave");
        btnsave.addEventListener("click", Options.save.bind(Options));
        var btnconfigurecommands = document.getElementById("btnconfigurecommands");
        btnconfigurecommands.addEventListener("click", Options.onBtnConfigureCommandsClick.bind(Options));
        this.reminderinterval = document.getElementById("reminderinterval");
        this.reminderinterval.addEventListener('input', function(){
             me.setDelay(this.value);
        });
        this.putVersion();
        this.checkUpdate();
    },
    putVersion: function() {
        this.pageTitle.innerHTML = this.pageTitle.innerHTML + ' ' + chrome.runtime.getManifest().version;
    },
    checkUpdate: function() {
        if (Common.getParam("update") == "true") {
            this.pageTitle.innerHTML = 'Quick Translate Updated ' + chrome.runtime.getManifest().version;
            this.pageTitle.style.textShadow = "0px 1px 1px #F74343";
            this.pageTitle.style.color = "#DB042D";
        }
    },
    onBtnConfigureCommandsClick: function() {
        chrome.tabs.create({
            url: "chrome://extensions/configureCommands"
        });
    },

    setDelay : function(delay){
        this.reminderinterval.value = delay;
        var txtdelay = document.getElementById("txtdelay");
        txtdelay.innerText = this.reminderinterval.value + ' min';
    },

    save: function() {
        var vals = {
            SRC_LANG: document.getElementById("srclang").value,
            DST_LANG: document.getElementById("dstlang").value,
            IGNORE_INPUTS: document.getElementById("ignoreinputs").checked,
            REMINDER: document.getElementById("reminder").checked,
            REMINDER_INTERVAL: document.getElementById("reminderinterval").value * this.MINUTE,
        };
        chrome.storage.sync.set(vals, function() {
            var txtmessage = document.getElementById("txtmessage");
            txtmessage.innerHTML = "Options saved";
            setTimeout(function() {
                txtmessage.innerHTML = "";
            }, 1000);
        });
    },
    restore: function() {
        var me = this;
        var srclang = document.getElementById("srclang");
        var dstlang = document.getElementById("dstlang");
        var ignoreinputs = document.getElementById("ignoreinputs");
        var reminder = document.getElementById("reminder");

        Object.keys(languages).forEach(function(key) {
            var displayValue = languages[key];
            var opt = document.createElement('option');
            opt.value = key;
            opt.innerHTML = displayValue;
            var otherNode = opt.cloneNode(true);
            srclang.appendChild(opt);
            dstlang.appendChild(otherNode);
        });
        chrome.storage.sync.get(Common.options, function(items) {
            srclang.value = items.SRC_LANG;
            dstlang.value = items.DST_LANG;
            ignoreinputs.checked = items.IGNORE_INPUTS;
            reminder.checked = items.REMINDER;
            me.setDelay(items.REMINDER_INTERVAL / me.MINUTE);
        });
    }
};
document.addEventListener('DOMContentLoaded', Options.init.bind(Options));